// ASD.js

var canvas = document.getElementById("diorama");
var canvasctx = canvas.getContext('2d');

var xsize, ysize, xcenter, ycenter;
var buffer;
var bufferctx;

var NBGSTARS = 200;
var bgstarX = new Array();
var bgstarY = new Array();

var NSTARS = 200;
var starX = new Array();
var starY = new Array();
var starZ = new Array();

var GRAYSCALE = 0;
var RED = 1;
var BLUE = 2;

var color = new Array();
var shade = new Array();

var loaded = false;
var image = new Image();
image.src = "galaxy.jpg";
image.onload = function()
{
   loaded = true;
}

var audio;

// Initialize star data, background canvas, and audio so that an audio file is
// playing.

function init()
{
   xsize = WIDTH;
   ysize = HEIGHT;
   xcenter = xsize>>1;
   ycenter = ysize>>1;

   buffer = document.createElement('canvas');
   buffer.width = WIDTH;
   buffer.height = HEIGHT;
   bufferctx = buffer.getContext('2d');
           
   for (n = 0; n < NSTARS; n++)
   {
      starX[n] = -xsize+(random(xsize)<<1);
      starY[n] = -ysize+(random(ysize)<<1);
      starZ[n] = 1+random(4095);
      var threshold = random(100);
      if (threshold < 93)
         color[n] = GRAYSCALE;
      else
      if (threshold < 96) // fewer red stars than grayscale stars
         color[n] = RED;
      else
         color[n] = BLUE; // fewer blue stars than red stars
   }
   for (n = 0; n < 256; n++)
      shade[255-n] = n;

   for (n = 0; n < NBGSTARS; n++)
   {
      bgstarX[n] = random(xsize);
      bgstarY[n] = random(ysize);
   }

   var filename;
   if (random(2) == 0)
      filename = "neptune.mp3";
   else
      filename = "saturn.mp3";
   document.writeln("<object classid='clsid:D27CDB6E-AE6D-11cf-96B8-444553540000'");
   document.writeln("        codebase='http:\/\/download.macromedia.com\/pub\/shockwave\/cabs\/flash\/swflash.cab#version=10,0,0,0'");
   document.writeln("        width='15' height='15'>");
   document.writeln("<PARAM NAME=movie VALUE='http:\/\/www.strangecube.com\/audioplay\/online\/audioplay.swf?file=http:\/\/tutortutor.ca\/software\/ASD\/"+filename+"&amp;auto=yes&amp;sendstop=yes&amp;repeat=1&amp;buttondir=http:\/\/www.strangecube.com\/audioplay\/online\/alpha_buttons\/negative_small&amp;bgcolor=0xffffff&amp;mode=playstop'>");
   document.writeln("<PARAM NAME=quality VALUE=high>");
   document.writeln("<PARAM NAME=wmode VALUE=transparent>");
   document.writeln("<embed src='http:\/\/www.strangecube.com\/audioplay\/online\/audioplay.swf?file=http:\/\/tutortutor.ca\/software\/ASD\/"+filename+"&amp;auto=yes&amp;sendstop=yes&amp;repeat=1&amp;buttondir=http:\/\/www.strangecube.com\/audioplay\/online\/alpha_buttons\/negative_small&amp;bgcolor=0xffffff&amp;mode=playstop'");
   document.writeln("       quality=high wmode=transparent width='15' height='15' align=''");
   document.writeln("       TYPE='application\/x-shockwave-flash'");
   document.writeln("       pluginspage='http:\/\/www.macromedia.com\/go\/getflashplayer'>");
   document.writeln("<\/embed>");
   document.writeln("<\/object>");
}

// Return a randomly generated integer ranging from 0 through limit-1.

function random(limit)
{
   return Math.floor(limit*Math.random());
}

// Render the next frame of animation.

function renderFrame()
{
   bufferctx.fillStyle = "RGB(0, 0, 0)";
   bufferctx.fillRect(0, 0, WIDTH, HEIGHT);

   bufferctx.fillStyle = "RGB(64, 64, 64)";
   for (n = 0; n < NBGSTARS; n++)
   {
      bufferctx.beginPath();
      bufferctx.arc(bgstarX[n], bgstarY[n], 1, 0, Math.PI*2, true);
      bufferctx.fill();
   }

   if (loaded)
      bufferctx.drawImage(image, (WIDTH-image.width)>>1,
                          (HEIGHT-image.height)>>1);

   for (n = 0; n < NSTARS; n++)
   {
      starZ[n] -= 30;
      if (starZ[n] < 1)
      {
         starX[n] = -xsize+(random(xsize)<<1);
         starY[n] = -ysize+(random(ysize)<<1);
         starZ[n] = 4095;
      }

      var z = starZ[n];
      var x = (starX[n]<<9)/z+xcenter;
      var y = (starY[n]<<9)/z+ycenter;
      var radius = (4095-z)/1364; // radius ranges from 0 through 3.

      bufferctx.beginPath();
      bufferctx.arc(x, y, radius, 0, Math.PI*2, true);

      var fs = "RGB(";
      switch (color[n])
      {
         case GRAYSCALE: fs += shade[z>>4]+","+shade[z>>4]+","+shade[z>>4]+")";
                         break;

         case RED      : fs += shade[z>>4]+",0,0)";
                         break;

         case BLUE     : fs += "0,0,"+shade[z>>4]+")";
      }
      bufferctx.fillStyle = fs;
      bufferctx.fill();
   }

   canvasctx.drawImage(buffer, 0, 0);
}

// Initialize the application and specify that renderFrame() is to be called
// every 5 milliseconds.

init();
setInterval(renderFrame, 5);
