function getChromeVersion()
{
   var index = navigator.userAgent.indexOf("Chrome/");
   if (index == -1)
      return null;
   var i = 7;
   var version = "";
   while ((ch = navigator.userAgent.substr(index+i, 1)) != " ")
   {
      version += ch;
      i++;
   }
   return version;
}

function getFirefoxVersion()
{
   var index = navigator.userAgent.indexOf("Firefox/");
   if (index == -1)
      return null;
   var i = 8;
   var length = navigator.userAgent.length;
   var version = "";
   while (index+i != length)
   {
      version += navigator.userAgent.substr(index+i, 1);
      i++;
   }
   return version;
}

function getInternetExplorerVersion()
{
   var index = navigator.userAgent.indexOf("MSIE");
   if (index == -1)
      return null;
   var i = 5;
   var version = "";
   while ((ch = navigator.userAgent.substr(index+i, 1)) != ";")
   {
      version += ch;
      i++;
   }
   return version;
}

function getOperaVersion()
{
   if (navigator.userAgent.indexOf("Opera") == -1)
      return null;
   var index = navigator.userAgent.indexOf("Version/");
   if (index == -1)
      return null;
   var i = 8;
   var version = "";
   while ((ch = navigator.userAgent.substr(index+i, 1)) != "")
   {
      version += ch;
      i++;
   }
   return version;
}

function getSafariVersion()
{
   if (navigator.userAgent.indexOf("Safari") == -1)
      return null;
   var index = navigator.userAgent.indexOf("Version/");
   if (index == -1)
      return null;
   var i = 8;
   var version = "";
   while ((ch = navigator.userAgent.substr(index+i, 1)) != " ")
   {
      version += ch;
      i++;
   }
   return version;
}

function cmp(a, b)
{
   var aFields = a.split(".");
   var bFields = b.split(".");
   var numFields = aFields.length;
   if (bFields.length < numFields)
      numFields = bFields.length;
   for (var i = 0; i < numFields; i++)
   {
      try
      {
         var x = parseInt(aFields[i]);
         var y = parseInt(bFields[i]);
         if (x != y)
            return x-y;
      }
      catch(e)
      {
         alert(e);
         return NaN;
      }
   }
   if (aFields.length == bFields.length)
      return 0;
   else
   if (aFields.length > bFields.length)
      return 1;
   else
      return -1;
}

// cmp() compares the strings passed to a and b. It assumes that each string
// is formatted as a sequence of period-separated integer fields (e.g.,
// 6.0.472.63), and returns one of the following values:
//
// * a positive value returns if a > b
// * a zero value returns if a = b
// * a negative value returns if a < b
// * NaN if one of a's or b's integer fields is found to be invalid (doesn't
//   begin with a digit, for example)
//
// Examples:
//
// alert(cmp("4.06", "4.06"));             // Output:  0
// alert(cmp("10.0.612.3", "6.0.472.63")); // Output:  4
// alert(cmp("6.0.472.63", "10.0.612.3")); // Output: -4
// alert(cmp("1.2.3", "1.2"));             // Output: 1
// alert(cmp("1.2", "1.2.3"));             // Output: -1
// alert(cmp("3", ""));                    // Output: NaN
